Description

Given the following flow with each of the users using the Firefox browser:

User A opens issue 42 (for viewing, the issue edit form is already rendered hidden)

User B opens issue 42 and changes the version field (or any other select box)

User A becomes aware of the change (e.g. via notification mails) and soft-reloads the issue view (F5 in Windows)

User A adds an issue note.

With the last update of User A, they inadvertently also update the Version field back to the value it had when User A first loaded the

issue in step 1. The cause of this is a peculiarity of how Firefox handles changes on forms with soft reloads. This is described on 

https://bugzilla.mozilla.org/show_bug.cgi?id=1279253. What happens here is that Firefox ignores the changed selected value on

select box and always retains the value it had on first load, even if the value was never actually changed by the user.

Unfortunately, this results in unwanted behaviour of the issue form (and possibly all other forms using select boxes like the project or

admin settings). If users are not very carefully, they might inadvertently overwrite values. This problem is not really detectable on the

server since the values sent by Firefox are valid. Here, it looks like the user just changed the value back.

After a couple of tests, it appears that Firefox takes the name attribute of a form tag into account to detect values of existing forms on

reload. If the name value changes, firefox doesn't take any changed values into account and assumes that the newly loaded form is

completely different. The attached patch leverages this behaviour by adding a random name attribute to all rendered forms. For

Firefox, this results in no form values being preserved on reload. Since Redmine already asks for confirmation on leave, this isn't

much of a loss probably.

The name attribute does not appear to be actually used for anything else and is thus save to be used here. Still, we preserve any

explicitly set name attribute.

Related issues:

Has duplicate Redmine - Defect #16015: Stale data is populated on Update if a... Closed

Associated revisions

Revision 18306 - 2019-06-20 18:46 - Jean-Philippe Lang

Add a randomized name attribute to all form fields (#26604).

This is a workaround for a Bug in Firefox described at

https://bugzilla.mozilla.org/show_bug.cgi?id=1279253

Patch by Holger Just.

History

#1 - 2017-08-03 11:21 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#2 - 2017-08-31 09:30 - Toshi MARUYAMA

- Target version changed from Candidate for next minor release to 4.1.0

#3 - 2019-06-20 18:46 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Committed, thanks.
https://bugzilla.mozilla.org/show_bug.cgi?id=1279253
https://stackoverflow.com/a/8946369/421705
https://bugzilla.mozilla.org/show_bug.cgi?id=1279253


#4 - 2024-10-23 13:04 - Holger Just

- Has duplicate Defect #16015: Stale data is populated on Update if another user has made changes added

Files

0001-Add-a-randomized-name-attribute-to-all-form-fields.patch 1.96 KB 2017-08-01 Holger Just

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

http://www.tcpdf.org

